import tsdoc from "eslint-plugin-tsdoc";
import globals from "globals";
import path from "node:path";
import { fileURLToPath } from "node:url";
import js from "@eslint/js";
import { FlatCompat } from "@eslint/eslintrc";

const __filename = fileURLToPath(import.meta.url);
const __dirname = path.dirname(__filename);
const compat = new FlatCompat({
    baseDirectory: __dirname,
    recommendedConfig: js.configs.recommended,
    allConfig: js.configs.all
});

export default [
    ...compat.extends("plugin:@typescript-eslint/recommended", "plugin:prettier/recommended"),
    {
        plugins: {
            tsdoc,
        },

        languageOptions: {
            globals: {
                ...globals.browser,
                ...globals.node,
                ...globals.mocha,
            },

            ecmaVersion: 2015,
            sourceType: "commonjs",
        },

        rules: {
            "tsdoc/syntax": "warn",
            "@typescript-eslint/no-inferrable-types": "off",
            "no-console": "warn",
            "arrow-parens": "warn",
        },
    },
];